local xw = require 'extraway'

--[[
<?xml version="1.0" encoding="ISO-8859-1"?>
<cmd stored=".attachTools.lookForLostAttachments">
</cmd>
--]]
local lookForLostAttachments = function()
   local records = xw.executeQuery("[UD,/xw/@UdType]=doc")
   local result = xw.prepareRecord("<stats/>")
   local root = result:selectFirstNode("/stats")
   if ( records:isValid() and 0 < #records ) then
      local record = records:getFirst()
      while ( record:isValid() ) do
         local nrecord = record:getFirstNodeValue("/doc/@nrecord")
         local newNode = nil
      
         local attachments = record:selectNodes("//*[name()='xw:file']")
         if ( attachments:isValid() and 0 < #attachments ) then
            local singleFile = attachments:getFirst()
            while ( singleFile:isValid() ) do
               -- Eval size to find lost attachments
               -- Get the attachment ID
               name = singleFile:getAttribute("name")
               name = xw.getAttachmentFileName(name)
               if ( 0 > xw.utils.getFileSize(name) ) then
                  if ( nil == newNode ) then
                     newNode = root:appendChild("doc")
                     newNode:setAttribute("nrecord", nrecord)
                  end
                  local att = newNode:appendChild("attachment", name)
                  att:setAttribute("name", singleFile:getAttribute("name"))
               end
            
               singleFile = attachments:getNext()
            end
         end
      
         record = records:getNext()
      end
   end
   
   return result:toString()
end

attachTools = {
   lookForLostAttachments = lookForLostAttachments,
   lookForLostAttachments_signature = {
      inParms = {},
      outParms = {"result"}
   }
}